package com.sf.vertx.handle;

import com.sf.vertx.api.pojo.AppCurrentLimitingConfig;
import com.sf.vertx.service.impl.AppConfigServiceImpl;
import com.sf.vertx.utils.ProxyTool;

import io.vertx.ext.web.RoutingContext;
import io.vertx.ext.web.handler.HttpException;
import lombok.extern.slf4j.Slf4j;

/***
 * redis存储
 * 
 * @author xy
 *
 */
@Slf4j
public class RateLimitHandlerRedisImpl implements RateLimitHandler {
	private RedisRateLimiter rateLimiter;
	private int pattern;// 1:app,2:接口默认,3:服务接口配置限流策略

	public RateLimitHandlerRedisImpl(RedisRateLimiter rateLimiter, int pattern) {
		this.rateLimiter = rateLimiter;
		this.pattern = pattern;
	}

	@Override
	public void handle(RoutingContext rc) {
		String sacAppHeaderKey = rc.request().headers().get(AppConfigServiceImpl.getSacAppHeaderKey());
		// TODO 判断是否开启限流配置
		log.info("RateLimitHandlerRedisImpl request:{}", sacAppHeaderKey);
//		rc.next();
//		return;
		// 获取模式
		// TODO redis连不上, 切换到内存模式
		if (rateLimiter.acquire(rc, pattern)) {
			log.info("rateLimiter.acquire true");
			rc.next();
			return;
		} else {
			switch (pattern) {
			case 1:
				AppCurrentLimitingConfig appCurrentLimitingConfig = AppConfigServiceImpl.getAppCurrentLimitingConfig(sacAppHeaderKey);
				rc.fail(new HttpException(429, appCurrentLimitingConfig.getDefaultResponse()));
				return;
			default:
				AppCurrentLimitingConfig appCurrentLimitingConfig1 = AppConfigServiceImpl.getAppCurrentLimitingConfig(sacAppHeaderKey);
				rc.fail(new HttpException(430, appCurrentLimitingConfig1.getDefaultResponse()));
				return;
			}
				
		}
	}
}
