package com.sf.vertx.handle;

import io.vertx.core.json.JsonObject;
import io.vertx.ext.web.RoutingContext;
import io.vertx.ext.web.handler.HttpException;
import lombok.extern.slf4j.Slf4j;
@Slf4j
public class RestfulFailureHandlerImpl implements RestfulFailureHandler {

	@Override
	public void handle(RoutingContext frc) {
		Throwable failure = frc.failure();
		log.info("Throwable error:{}", failure);
		if (failure instanceof HttpException) {
			HttpException httpException = (HttpException) failure;
			// frc.response().setStatusCode(404).end();
			JsonObject dataJson = new JsonObject(httpException.getPayload());
			frc.response().setChunked(true).setStatusCode(httpException.getStatusCode())
					.putHeader("Content-Type", "application/json").end(dataJson.toBuffer());
			return;
		}
		frc.response().setChunked(true).setStatusCode(400)
		.putHeader("Content-Type", "application/json").end("{\n" + "    \"msg\": \"接口繁忙请重试\",\n" + "    \"code\": 501,\n" + "    \"data\": \"到达限流阈值\"\n" + "}");
		return;
	}

}
